/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FILITIPOCARD                                             */
/* Tabela : FILITIPOCARD                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 08/03/2005 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FILITIPOCARD
BEFORE INSERT OR UPDATE OR DELETE
ON FILITIPOCARD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFTCA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.IDTCARATFILI,0) <> NVL(:NEW.IDTCARATFILI,0)) THEN
         :NEW.DTULTATUFTCA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FILITIPOCARD', '', 'CDFILCENTPME='||:OLD.CDFILCENTPME||';CDTIPOCARD='||:OLD.CDTIPOCARD||';CDFILIAL='||:OLD.CDFILIAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FILITIPOCARD MODIFY DTULTATUFTCA DEFAULT SYSDATE
/