/* Tabela IMPRESSORA: TABELA DE IMPRESSORA */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela IMPRESSORA*/
/* Objetivo: Gerar um log que vai registrar as alteraes na IMPRESSORA,
             utilizando a tabela de Logs de Operaes do VND*/

CREATE OR REPLACE TRIGGER LOG_VND_IMPRESSORA
AFTER DELETE OR INSERT OR UPDATE
ON IMPRESSORA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN

	  IF NVL(:NEW.CDIMPRESSORA,'NULL') <> NVL(:OLD.CDIMPRESSORA,'NULL') THEN 
         V_DESC := 'Cd Impressora ' || '' || NVL(:NEW.CDIMPRESSORA,'' );
      END IF;
      IF NVL(:NEW.NMIMPRESSORA,'NULL') <> NVL(:OLD.NMIMPRESSORA,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Nm Impressora ' || '' || NVL(:NEW.NMIMPRESSORA,''  );
      END IF;
	  IF NVL(:NEW.IDTIPOIMPRES,'NULL') <> NVL(:OLD.IDTIPOIMPRES,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Id Tipo Impressora ' || '' || NVL(:NEW.IDTIPOIMPRES,'' );
      END IF;
	  IF NVL(:NEW.IDMODEIMPRES,'NULL') <> NVL(:OLD.IDMODEIMPRES,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Id Mode Impressora ' || '' || NVL(:NEW.IDMODEIMPRES,'' );
      END IF;
	  IF NVL(:NEW.DTULTATUIMPR,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUIMPR,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Data Ult Atu Impressora ' || '' || NVL(:NEW.DTULTATUIMPR,'');
      END IF;

      V_ITPESQ := :NEW.CDIMPRESSORA;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN

      V_DESC   := 'Cd Impressora '        || '' || NVL(:NEW.CDIMPRESSORA,''    )     || ' ' ||
                  'Nm Impressora  '       || '' || NVL(:NEW.NMIMPRESSORA,''  )       || ' ' ||
                  'Id Tipo Impressora '   || '' || NVL(:NEW.IDTIPOIMPRES,'' )        || ' ' ||
                  'Id Mode Impressora  '  || '' || NVL(:NEW.IDMODEIMPRES,'' )        || ' ' ||
                  'Data Ult Atu Impressora  '       || '' || NVL(:NEW.DTULTATUIMPR,''  );

      V_ITPESQ := :NEW.CDIMPRESSORA;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cd Impressora '        || '' || NVL(:OLD.CDIMPRESSORA,''    )     || ' ' ||
                  'Nm Impressora  '       || '' || NVL(:OLD.NMIMPRESSORA,''  )       || ' ' ||
                  'Id Tipo Impressora '   || '' || NVL(:OLD.IDTIPOIMPRES,'' )        || ' ' ||
                  'Id Mode Impressora  '  || '' || NVL(:OLD.IDMODEIMPRES,'' )        || ' ' ||
                  'Data Ult Atu Impressora  '       || '' || NVL(:OLD.DTULTATUIMPR,''  );

            V_ITPESQ := :OLD.CDIMPRESSORA;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('IMPRESSORA',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       '');
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_IMPRESSORA','5.20.001'); END;
/



