/* Sistemas Integrados TECNISA

Nome: 9545_QPRTRGO_LOG_QPR_INSPECAUDIT.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   04/01/2018 - Jurandir Junio
*/

/* Tabela INSPECAUDIT.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              INSPECAUDIT, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_QPR_INSPECAUDIT
AFTER DELETE OR INSERT OR UPDATE
ON INSPECAUDIT FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';  
   V_CONT_LENGTH  := 1;
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.NRAUDITORIA IS NOT NULL THEN
            V_DESC := V_DESC || 'NrAudit.= ' || NVL(:NEW.NRAUDITORIA,'') || ' ' ;
         END IF;

         IF :NEW.NRINSPECAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'NrInspecAudit= ' || NVL(:NEW.NRINSPECAUDI,'') || ' ';
         END IF;

         IF :NEW.DTINIPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtInipInsAud= ' || NVL(TO_CHAR(:NEW.DTINIPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.DTFINPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtFinpInsAud= ' || NVL(TO_CHAR(:NEW.DTFINPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.DTINIRINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtInirInsAud= ' || NVL(TO_CHAR(:NEW.DTINIRINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.DTFINRINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtFinrInsAud= ' || NVL(TO_CHAR(:NEW.DTFINRINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.IDOPERINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'IdOperInsAud= ' || TO_CHAR(:NEW.IDOPERINSAUD) || ' ';
         END IF;

         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;

         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdInspecao= ' || :NEW.CDINSPECAO || ' ';
         END IF;

         IF :NEW.CDNORMA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdNorma=  ' || :NEW.CDNORMA || ' ';
         END IF;

         IF :NEW.CDCLAUSULA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdClausula= ' || :NEW.CDCLAUSULA || ' ';
         END IF;

         IF :NEW.CDTIPORESU IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoResu= ' || :NEW.CDTIPORESU || ' ';
         END IF;

         IF :NEW.DSINSPECAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'DsInspecAudi= ' || TO_CHAR(:NEW.DSINSPECAUDI, 'DD/MM/YYYY') || ' ';
         END IF;

         IF :NEW.CDTABEPROC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTabeProc= ' || :NEW.CDTABEPROC || ' ';
         END IF;

         IF :NEW.CDPROCED IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProced= ' || :NEW.CDPROCED || ' ';
         END IF;

         IF :NEW.IDNOVAAMOSTR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdNovaAmostr= ' || :NEW.IDNOVAAMOSTR || ' ' ;
         END IF;

         IF :NEW.IDINSPCONC IS NOT NULL THEN
            V_DESC := V_DESC || 'IdInspConc= ' || :NEW.IDINSPCONC || ' ' ;
         END IF;

         IF :NEW.QTHRINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'QtHrInsAud= ' || :NEW.QTHRINSAUD || ' ' ;
         END IF;

         IF :NEW.IDTIPOINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTipoInsAud= ' || :NEW.IDTIPOINSAUD || ' ' ;
         END IF;

         IF :NEW.QTHRPADINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'QtHrPadInsp= ' || :NEW.QTHRPADINSP || ' ' ;
         END IF;

         IF :NEW.CDOPECONCINS IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOpeConcIns= ' || :NEW.CDOPECONCINS || ' ' ;
         END IF;

         IF :NEW.CDCOBAIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdCobaia= ' || :NEW.CDCOBAIA || ' ' ;
         END IF;

         IF :NEW.CDORDEMAUDIT IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOrdemAudit= ' || :NEW.CDORDEMAUDIT || ' ' ;
         END IF;

         IF :NEW.DSANALISE IS NOT NULL THEN
            V_DESC := V_DESC || 'DsAnalise= ' || :NEW.DSANALISE || ' ' ;
         END IF;

      V_ITPESQ := :NEW.CDFILIAL || :NEW.NRAUDITORIA || :NEW.NRINSPECAUDI;

      V_IDTIPOOPER := '1';
      V_CDFILLOGOPER := :NEW.CDFILIAL;

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.NRAUDITORIA <> :OLD.NRAUDITORIA) THEN
            V_DESC := V_DESC || 'NrAudit= ' || NVL(:NEW.NRAUDITORIA,'') || ' ' ;
         END IF;

         IF (:NEW.NRINSPECAUDI <> :OLD.NRINSPECAUDI) THEN
            V_DESC := V_DESC || 'NrInspecAudi= ' || NVL(:NEW.NRINSPECAUDI,'') || ' ';
         END IF;

         IF (:NEW.DTINIPINSAUD <> :OLD.DTINIPINSAUD) THEN
            V_DESC := V_DESC || 'DtInipInsAud= ' || NVL(TO_CHAR(:NEW.DTINIPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.DTFINPINSAUD <> :OLD.DTFINPINSAUD) THEN
            V_DESC := V_DESC || 'DtFinpInsAud= ' || NVL(TO_CHAR(:NEW.DTFINPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.DTINIRINSAUD <> :OLD.DTINIRINSAUD) THEN
            V_DESC := V_DESC || 'DtInirInsAud= ' || NVL(TO_CHAR(:NEW.DTINIRINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.DTFINRINSAUD <> :OLD.DTFINRINSAUD) THEN
            V_DESC := V_DESC || 'DtFinrInsAud= ' || NVL(TO_CHAR(:NEW.DTFINRINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.IDOPERINSAUD <> :OLD.IDOPERINSAUD) THEN
            V_DESC := V_DESC || 'IdOperInsAud= ' || TO_CHAR(:NEW.IDOPERINSAUD) || ' ';
         END IF;  

         IF (:NEW.CDOPERADOR <> :OLD.CDOPERADOR) THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;  
         
         IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
            V_DESC := V_DESC || 'CdInspecao= ' || :NEW.CDINSPECAO || ' ';
         END IF;

         IF (:NEW.CDNORMA <> :OLD.CDNORMA) THEN
            V_DESC := V_DESC || 'CdNorma=  ' || :NEW.CDNORMA || ' ';
         END IF; 

         IF (:NEW.CDCLAUSULA <> :OLD.CDCLAUSULA) THEN
            V_DESC := V_DESC || 'CdClausula= ' || :NEW.CDCLAUSULA || ' ';
         END IF;  

         IF (:NEW.CDTIPORESU <> :OLD.CDTIPORESU) THEN
            V_DESC := V_DESC || 'CdTipoResu= ' || :NEW.CDTIPORESU || ' ';
         END IF;  

         IF (:NEW.DSINSPECAUDI <> :OLD.DSINSPECAUDI) THEN
            V_DESC := V_DESC || 'DsInspecAudi= ' || TO_CHAR(:NEW.DSINSPECAUDI, 'DD/MM/YYYY') || ' ';
         END IF;  
         
         IF (:NEW.CDTABEPROC <> :OLD.CDTABEPROC) THEN
            V_DESC := V_DESC || 'CdTabeProc= ' || :NEW.CDTABEPROC || ' ';
         END IF;

         IF (:NEW.CDPROCED <> :OLD.CDPROCED) THEN
            V_DESC := V_DESC || 'CdProced= ' || :NEW.CDPROCED || ' ';
         END IF;

         IF (:NEW.IDNOVAAMOSTR <> :OLD.IDNOVAAMOSTR) THEN
            V_DESC := V_DESC || 'IdNovaAmostr= ' || :NEW.IDNOVAAMOSTR || ' ';
         END IF;

         IF (:NEW.IDINSPCONC <> :OLD.IDINSPCONC) THEN
            V_DESC := V_DESC || 'IdInspConc= ' || :NEW.IDINSPCONC || ' ';
         END IF;  

         IF (:NEW.QTHRINSAUD <> :OLD.QTHRINSAUD) THEN
            V_DESC := V_DESC || 'QtHrInsAud= ' || :NEW.QTHRINSAUD || ' ' ;
         END IF;

         IF (:NEW.IDTIPOINSAUD <> :OLD.IDTIPOINSAUD) THEN
            V_DESC := V_DESC || 'IdTipoInsAud= ' || :NEW.IDTIPOINSAUD || ' ' ;
         END IF;

         IF (:NEW.QTHRPADINSP <> :OLD.QTHRPADINSP) THEN
            V_DESC := V_DESC || 'QtHrPadInsp= ' || :NEW.QTHRPADINSP || ' ' ;
         END IF;

         IF (:NEW.CDOPECONCINS <> :OLD.CDOPECONCINS) THEN
            V_DESC := V_DESC || 'CdOpeConcIns= ' || :NEW.CDOPECONCINS || ' ' ;
         END IF;

         IF (:NEW.CDCOBAIA <> :OLD.CDCOBAIA) THEN
            V_DESC := V_DESC || 'CdCobaia= ' || :NEW.CDCOBAIA || ' ' ;
         END IF;

         IF (:NEW.CDORDEMAUDIT <> :OLD.CDORDEMAUDIT) THEN
            V_DESC := V_DESC || 'CdOrdemAudit= ' || :NEW.CDORDEMAUDIT || ' ' ;
         END IF;

         IF (:NEW.DSANALISE <> :OLD.DSANALISE) THEN
            V_DESC := V_DESC || 'DsAnalise= ' || :NEW.DSANALISE || ' ' ;
         END IF;

      V_ITPESQ := :NEW.CDFILIAL || :NEW.NRAUDITORIA || :NEW.NRINSPECAUDI;

          V_IDTIPOOPER := '2';    
          V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.NRAUDITORIA IS NOT NULL THEN
            V_DESC := V_DESC || 'NrAudit.= ' || NVL(:OLD.NRAUDITORIA,'') || ' ' ;
         END IF;

         IF :OLD.NRINSPECAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'NrInspecAudit= ' || NVL(:OLD.NRINSPECAUDI,'') || ' ';
         END IF;

         IF :OLD.DTINIPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtInipInsAud= ' || NVL(TO_CHAR(:OLD.DTINIPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.DTFINPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtFinpInsAud= ' || NVL(TO_CHAR(:OLD.DTFINPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.DTINIRINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtInirInsAud= ' || NVL(TO_CHAR(:OLD.DTINIRINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.DTFINRINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtFinrInsAud= ' || NVL(TO_CHAR(:OLD.DTFINRINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.IDOPERINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'IdOperInsAud= ' || TO_CHAR(:OLD.IDOPERINSAUD) || ' ';
         END IF;

         IF :OLD.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:OLD.CDOPERADOR,'') || ' ';
         END IF;

         IF :OLD.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdInspecao= ' || :OLD.CDINSPECAO || ' ';
         END IF;

         IF :OLD.CDNORMA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdNorma=  ' || :OLD.CDNORMA || ' ';
         END IF;

         IF :OLD.CDCLAUSULA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdClausula= ' || :OLD.CDCLAUSULA || ' ';
         END IF;

         IF :OLD.CDTIPORESU IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoResu= ' || :OLD.CDTIPORESU || ' ';
         END IF;

         IF :OLD.DSINSPECAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'DsInspecAudi= ' || TO_CHAR(:OLD.DSINSPECAUDI, 'DD/MM/YYYY') || ' ';
         END IF;

         IF :OLD.CDTABEPROC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTabeProc= ' || :OLD.CDTABEPROC || ' ';
         END IF;

         IF :OLD.CDPROCED IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProced= ' || :OLD.CDPROCED || ' ';
         END IF;

         IF :OLD.IDNOVAAMOSTR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdNovaAmostr= ' || :OLD.IDNOVAAMOSTR || ' ' ;
         END IF;

         IF :OLD.IDINSPCONC IS NOT NULL THEN
            V_DESC := V_DESC || 'IdInspConc= ' || :OLD.IDINSPCONC || ' ' ;
         END IF;

         IF :OLD.QTHRINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'QtHrInsAud= ' || :OLD.QTHRINSAUD || ' ' ;
         END IF;

         IF :OLD.IDTIPOINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTipoInsAud= ' || :OLD.IDTIPOINSAUD || ' ' ;
         END IF;

         IF :OLD.QTHRPADINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'QtHrPadInsp= ' || :OLD.QTHRPADINSP || ' ' ;
         END IF;

         IF :OLD.CDOPECONCINS IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOpeConcIns= ' || :OLD.CDOPECONCINS || ' ' ;
         END IF;

         IF :OLD.CDCOBAIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdCobaia= ' || :OLD.CDCOBAIA || ' ' ;
         END IF;

         IF :OLD.CDORDEMAUDIT IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOrdemAudit= ' || :OLD.CDORDEMAUDIT || ' ' ;
         END IF;

         IF :OLD.DSANALISE IS NOT NULL THEN
            V_DESC := V_DESC || 'DsAnalise= ' || :OLD.DSANALISE || ' ' ;
         END IF;

      V_ITPESQ := :OLD.CDFILIAL || :OLD.NRAUDITORIA || :OLD.NRINSPECAUDI;

      V_IDTIPOOPER := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;

   END IF;   

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA (NMTABELA,       DTOPERACAO,     NMRESPOPER,
                               IDTIPOOPER,     DSOPERACAO,     CDPESQITEM,
                               DSRDMUSUOPER,   DSENDUSUOPER,   DSNMUSUOPER,
                               DSMETUSUOPER,   CDORESPOPER,    CDFILLOGOPER)
                      VALUES  ('INSPECAUDIT',  SYSDATE ,       NVL(V_NMOPERADOR,' '),
                               V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                               V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                               V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);
  
      END LOOP;       
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_QPR_INSPECAUDIT','6.19.xxx'); END;
/
