var TcoAuthRunner = function(tcoAuthFunctions) {
    /**
     * Run functions defined at TcoAuthFunctions
     * after run this.defaultFunctions. Pass responseUrl
     * and reponse data as params.
     * 
     * @param {Response} response Response data
     * passed by from TcoAuthListener.
     */
    this.run = function(response) {
        var responseURL = getReducedValidURL(response.responseURL);
        var responseData = response.response;
        var functionPerRoute = tcoAuthFunctions.functionByRoute[responseURL] || null;

        tcoAuthFunctions.defaultFunctions.forEach(functionToCall => {
            functionToCall(responseData, responseURL);
        });

        if (functionPerRoute) {
            functionPerRoute(responseData, responseURL);
        }
    };

    /**
     * Return a parsed chopped URL if it comes
     * from tco/index.php, or null if not.
     * 
     * @param {String} url
     */
    var getReducedValidURL = function(url) {
        var returnUrl = null;

        if (url.indexOf('index.php/') > -1) {
            returnUrl = url.slice(url.indexOf('index.php/') + 9);
        }

        return returnUrl;
    };
};
